diff -aruN --binary 15/libraries/joomla/database/table.php 16/libraries/joomla/database/table.php
--- 15/libraries/joomla/database/table.php	2009-05-29 13:54:30.000000000 +0200
+++ 16/libraries/joomla/database/table.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: table.php 11646 2009-03-01 19:34:56Z ian $
+ * @version		$Id: table.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	Table
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/document/document.php 16/libraries/joomla/document/document.php
--- 15/libraries/joomla/document/document.php	2009-05-29 13:54:34.000000000 +0200
+++ 16/libraries/joomla/document/document.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: document.php 10816 2008-08-27 04:17:00Z tcp $
+* @version		$Id: document.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Document
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/document/error/error.php 16/libraries/joomla/document/error/error.php
--- 15/libraries/joomla/document/error/error.php	2009-05-29 13:54:34.000000000 +0200
+++ 16/libraries/joomla/document/error/error.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: error.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: error.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Document
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/document/feed/feed.php 16/libraries/joomla/document/feed/feed.php
--- 15/libraries/joomla/document/feed/feed.php	2009-05-29 13:54:32.000000000 +0200
+++ 16/libraries/joomla/document/feed/feed.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: feed.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: feed.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Document
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/document/feed/renderer/atom.php 16/libraries/joomla/document/feed/renderer/atom.php
--- 15/libraries/joomla/document/feed/renderer/atom.php	2009-05-29 13:54:32.000000000 +0200
+++ 16/libraries/joomla/document/feed/renderer/atom.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: atom.php 11687 2009-03-11 17:49:23Z ian $
+ * @version		$Id: atom.php 15105 2010-02-27 14:59:11Z ian $
  * @package		Joomla.Framework
  * @subpackage	Document
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
@@ -50,7 +50,7 @@
 	{
 		$now	=& JFactory::getDate();
 		$data	=& $this->_doc;
-		
+
 		$uri =& JFactory::getURI();
 		$url = $uri->toString(array('scheme', 'user', 'pass', 'host', 'port'));
 		$syndicationURL =& JRoute::_('&format=feed&type=atom');
@@ -100,8 +100,8 @@
 				$feed.= "		</author>\n";
 			}
 			if ($data->items[$i]->description!="") {
-				$feed.= "		<summary type=\"html\">".htmlspecialchars($data->items[$i]->description, ENT_COMPAT, 'UTF-8')."</summary>\n";
-				$feed.= "		<content type=\"html\">".htmlspecialchars($data->items[$i]->description, ENT_COMPAT, 'UTF-8')."</content>\n";
+				$feed.= "		<summary type=\"html\">".htmlspecialchars($this->_relToAbs($data->items[$i]->description))."</summary>\n";
+				$feed.= "		<content type=\"html\">".htmlspecialchars($this->_relToAbs($data->items[$i]->description))."</content>\n";
 			}
 			if ($data->items[$i]->enclosure != NULL) {
 			$feed.="		<link rel=\"enclosure\" href=\"". $data->items[$i]->enclosure->url ."\" type=\"". $data->items[$i]->enclosure->type."\"  length=\"". $data->items[$i]->enclosure->length . "\" />\n";
@@ -111,4 +111,12 @@
 		$feed.= "</feed>\n";
 		return $feed;
 	}
+
+	function _relToAbs($text)
+	{
+		$base = JURI::base();
+  		$text = preg_replace("/(href|src)=\"(?!http|ftp|https|mailto)([^\"]*)\"/", "$1=\"$base\$2\"", $text);
+
+		return $text;
+	}
 }
diff -aruN --binary 15/libraries/joomla/document/feed/renderer/rss.php 16/libraries/joomla/document/feed/renderer/rss.php
--- 15/libraries/joomla/document/feed/renderer/rss.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/libraries/joomla/document/feed/renderer/rss.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: rss.php 13310 2009-10-24 04:09:35Z ian $
+ * @version		$Id: rss.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	Document
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/document/html/html.php 16/libraries/joomla/document/html/html.php
--- 15/libraries/joomla/document/html/html.php	2009-05-29 13:54:34.000000000 +0200
+++ 16/libraries/joomla/document/html/html.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: html.php 10787 2008-08-24 07:45:36Z pasamio $
+* @version		$Id: html.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Document
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/document/html/renderer/component.php 16/libraries/joomla/document/html/renderer/component.php
--- 15/libraries/joomla/document/html/renderer/component.php	2009-05-29 13:54:32.000000000 +0200
+++ 16/libraries/joomla/document/html/renderer/component.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: component.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: component.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Document
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/document/html/renderer/head.php 16/libraries/joomla/document/html/renderer/head.php
--- 15/libraries/joomla/document/html/renderer/head.php	2009-05-29 14:32:52.000000000 +0200
+++ 16/libraries/joomla/document/html/renderer/head.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: head.php 11917 2009-05-29 19:37:05Z ian $
+* @version		$Id: head.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Document
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/document/html/renderer/message.php 16/libraries/joomla/document/html/renderer/message.php
--- 15/libraries/joomla/document/html/renderer/message.php	2009-05-29 13:54:32.000000000 +0200
+++ 16/libraries/joomla/document/html/renderer/message.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: message.php 10707 2008-08-21 09:52:47Z eddieajau $
+ * @version		$Id: message.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	Document
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/document/html/renderer/module.php 16/libraries/joomla/document/html/renderer/module.php
--- 15/libraries/joomla/document/html/renderer/module.php	2009-06-30 21:01:32.000000000 +0200
+++ 16/libraries/joomla/document/html/renderer/module.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: module.php 12231 2009-06-21 02:16:14Z ian $
+* @version		$Id: module.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Document
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/document/html/renderer/modules.php 16/libraries/joomla/document/html/renderer/modules.php
--- 15/libraries/joomla/document/html/renderer/modules.php	2009-05-29 13:54:32.000000000 +0200
+++ 16/libraries/joomla/document/html/renderer/modules.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: modules.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: modules.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Document
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/document/pdf/pdf.php 16/libraries/joomla/document/pdf/pdf.php
--- 15/libraries/joomla/document/pdf/pdf.php	2009-05-29 13:54:34.000000000 +0200
+++ 16/libraries/joomla/document/pdf/pdf.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: pdf.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: pdf.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Document
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/document/raw/raw.php 16/libraries/joomla/document/raw/raw.php
--- 15/libraries/joomla/document/raw/raw.php	2009-05-29 13:54:34.000000000 +0200
+++ 16/libraries/joomla/document/raw/raw.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: raw.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: raw.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Document
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/document/renderer.php 16/libraries/joomla/document/renderer.php
--- 15/libraries/joomla/document/renderer.php	2009-05-29 13:54:34.000000000 +0200
+++ 16/libraries/joomla/document/renderer.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: renderer.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: renderer.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Document
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/environment/browser.php 16/libraries/joomla/environment/browser.php
--- 15/libraries/joomla/environment/browser.php	2009-05-29 13:54:28.000000000 +0200
+++ 16/libraries/joomla/environment/browser.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version      $Id: browser.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version      $Id: browser.php 14401 2010-01-26 14:10:00Z louis $
 * @package      Joomla.Framework
 * @subpackage   Environment
-* @copyright    Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright    Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license      GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/environment/request.php 16/libraries/joomla/environment/request.php
--- 15/libraries/joomla/environment/request.php	2009-05-29 13:54:28.000000000 +0200
+++ 16/libraries/joomla/environment/request.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: request.php 10919 2008-09-09 20:50:29Z willebil $
+ * @version		$Id: request.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	Environment
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/environment/response.php 16/libraries/joomla/environment/response.php
--- 15/libraries/joomla/environment/response.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/libraries/joomla/environment/response.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: response.php 13341 2009-10-27 03:03:54Z ian $
+ * @version		$Id: response.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	Environment
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/environment/uri.php 16/libraries/joomla/environment/uri.php
--- 15/libraries/joomla/environment/uri.php	2009-06-30 21:01:32.000000000 +0200
+++ 16/libraries/joomla/environment/uri.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: uri.php 12389 2009-07-01 00:34:45Z ian $
+ * @version		$Id: uri.php 16382 2010-04-23 09:33:59Z ian $
  * @package		Joomla.Framework
  * @subpackage	Environment
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
@@ -157,12 +157,17 @@
 				 * running on IIS and will therefore need to work some magic with the SCRIPT_NAME and
 				 * QUERY_STRING environment variables.
 				 */
+				
+				 	if (strlen($_SERVER['QUERY_STRING']) && strpos($_SERVER['REQUEST_URI'], $_SERVER['QUERY_STRING']) === false) {
+						$theURI .= '?'.$_SERVER['QUERY_STRING'];
+					}
+
 				}
 				 else
 				 {
 					// IIS uses the SCRIPT_NAME variable instead of a REQUEST_URI variable... thanks, MS
 					$theURI = 'http' . $https . $_SERVER['HTTP_HOST'] . $_SERVER['SCRIPT_NAME'];
-
+		
 					// If the query string exists append it to the URI string
 					if (isset($_SERVER['QUERY_STRING']) && !empty($_SERVER['QUERY_STRING'])) {
 						$theURI .= '?' . $_SERVER['QUERY_STRING'];
diff -aruN --binary 15/libraries/joomla/error/error.php 16/libraries/joomla/error/error.php
--- 15/libraries/joomla/error/error.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/libraries/joomla/error/error.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: error.php 13385 2009-10-29 13:35:54Z ian $
+ * @version		$Id: error.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	Error
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/error/exception.php 16/libraries/joomla/error/exception.php
--- 15/libraries/joomla/error/exception.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/error/exception.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: exception.php 10381 2008-06-01 03:35:53Z pasamio $
+ * @version		$Id: exception.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	Error
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/error/log.php 16/libraries/joomla/error/log.php
--- 15/libraries/joomla/error/log.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/error/log.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: log.php 10707 2008-08-21 09:52:47Z eddieajau $
+ * @version		$Id: log.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	Error
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/error/profiler.php 16/libraries/joomla/error/profiler.php
--- 15/libraries/joomla/error/profiler.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/error/profiler.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,10 +1,10 @@
 <?php
 
 /**
-* @version		$Id: profiler.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: profiler.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Error
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/event/dispatcher.php 16/libraries/joomla/event/dispatcher.php
--- 15/libraries/joomla/event/dispatcher.php	2009-05-29 13:54:20.000000000 +0200
+++ 16/libraries/joomla/event/dispatcher.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: dispatcher.php 11387 2009-01-04 02:47:53Z ian $
+* @version		$Id: dispatcher.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Event
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/event/event.php 16/libraries/joomla/event/event.php
--- 15/libraries/joomla/event/event.php	2009-05-29 13:54:20.000000000 +0200
+++ 16/libraries/joomla/event/event.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: event.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: event.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Event
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/factory.php 16/libraries/joomla/factory.php
--- 15/libraries/joomla/factory.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/libraries/joomla/factory.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
- * @version		$Id: factory.php 13341 2009-10-27 03:03:54Z ian $
+ * @version		$Id: factory.php 15184 2010-03-04 23:18:17Z ian $
  * @package		Joomla.Framework
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
@@ -331,6 +331,7 @@
 						JPATH_BASE.DS.'cache',
 						isset( $options['cache_time'] ) ? $options['cache_time'] : 0
 					);
+					$simplepie->force_feed(true);
 					$simplepie->handle_content_type();
 					if ($simplepie->init()) {
 						$doc = $simplepie;
diff -aruN --binary 15/libraries/joomla/filesystem/archive/bzip2.php 16/libraries/joomla/filesystem/archive/bzip2.php
--- 15/libraries/joomla/filesystem/archive/bzip2.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/filesystem/archive/bzip2.php	2010-04-23 13:40:18.000000000 +0200
@@ -3,7 +3,7 @@
  * @version		$Id:bzip2.php 6961 2007-03-15 16:06:53Z tcp $
  * @package		Joomla.Framework
  * @subpackage	FileSystem
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/filesystem/archive/gzip.php 16/libraries/joomla/filesystem/archive/gzip.php
--- 15/libraries/joomla/filesystem/archive/gzip.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/filesystem/archive/gzip.php	2010-04-23 13:40:18.000000000 +0200
@@ -3,7 +3,7 @@
  * @version		$Id:gzip.php 6961 2007-03-15 16:06:53Z tcp $
  * @package		Joomla.Framework
  * @subpackage	FileSystem
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/filesystem/archive/tar.php 16/libraries/joomla/filesystem/archive/tar.php
--- 15/libraries/joomla/filesystem/archive/tar.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/filesystem/archive/tar.php	2010-04-23 13:40:18.000000000 +0200
@@ -3,7 +3,7 @@
  * @version		$Id:tar.php 6961 2007-03-15 16:06:53Z tcp $
  * @package		Joomla.Framework
  * @subpackage	FileSystem
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/filesystem/archive/zip.php 16/libraries/joomla/filesystem/archive/zip.php
--- 15/libraries/joomla/filesystem/archive/zip.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/filesystem/archive/zip.php	2010-04-23 13:40:18.000000000 +0200
@@ -3,7 +3,7 @@
  * @version		$Id:zip.php 6961 2007-03-15 16:06:53Z tcp $
  * @package		Joomla.Framework
  * @subpackage	FileSystem
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/filesystem/archive.php 16/libraries/joomla/filesystem/archive.php
--- 15/libraries/joomla/filesystem/archive.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/libraries/joomla/filesystem/archive.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: archive.php 13341 2009-10-27 03:03:54Z ian $
+ * @version		$Id: archive.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	FileSystem
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/filesystem/file.php 16/libraries/joomla/filesystem/file.php
--- 15/libraries/joomla/filesystem/file.php	2009-07-23 03:25:36.000000000 +0200
+++ 16/libraries/joomla/filesystem/file.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: file.php 12541 2009-07-22 17:36:38Z ian $
+ * @version		$Id: file.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	FileSystem
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/filesystem/folder.php 16/libraries/joomla/filesystem/folder.php
--- 15/libraries/joomla/filesystem/folder.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/filesystem/folder.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: folder.php 11675 2009-03-08 20:43:54Z willebil $
+ * @version		$Id: folder.php 15203 2010-03-05 09:21:16Z ian $
  * @package		Joomla.Framework
  * @subpackage	FileSystem
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
@@ -564,8 +564,16 @@
 	function makeSafe($path)
 	{
 		$ds = (DS == '\\') ? '\\' . DS : DS;
-		$regex = array('#[^A-Za-z0-9:\_\-' . $ds . ' ]#');
-		return preg_replace($regex, '', $path);
+		$regex = array('#[^A-Za-z0-9:\_\-\.' . $ds . ' ]#');
+		$safepath = preg_replace($regex, '', $path);  // check if all chars are legal
+		$parts = explode('\\', $safepath);
+		$safepath = '';
+		foreach ($parts as $part) {
+		  if ( ($part !== '.') & ($part !== '..') ) {
+		    $safepath .=  '\\'. trim(str_replace('..', '.', $part),'.');
+		  }
+		}
+		return $safepath;
 	}
 
 }
\ No hay ningún carácter de nueva línea al final del fichero
diff -aruN --binary 15/libraries/joomla/filesystem/path.php 16/libraries/joomla/filesystem/path.php
--- 15/libraries/joomla/filesystem/path.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/libraries/joomla/filesystem/path.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: path.php 13341 2009-10-27 03:03:54Z ian $
+ * @version		$Id: path.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	FileSystem
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
